abbr_dict = {'( |^)(\d{1,2}|\d{4,5}|\d{6}\d+)([\-\–\—])(\d+)([ \.,\!\?]|$)': '\g<1>\g<2> \g<3> \g<4>\g<5>',
			 '( |^)(\d+)([\-\–\—])(\d{1,3}|\d{4}\d+)([ \.,\!\?]|$)': '\g<1>\g<2> \g<3> \g<4>\g<5>',
			 '(\d+\.) gr\.(\W|$)': '\g<1> grein\g<2>',
			 '(\d+\.) mgr\.(\W|$)': '\g<1> málsgrein\g<2>',
			 '(\d+\.) nmgr\.(\W|$)': '\g<1> neðanmálsgrein\g<2>',
			 '(\W|^)[Ii]nnsk\. (blm\.|blaðamanns)': '\g<1>innskot \g<2>',
			 '(\W|^)([Ii]nnsk(\.|ot) )(blm\.)(\W|$)': '\g<1>\g<2>blaðamanns \g<5>',
			 ' ([Ff]\.[Kk]r\.?)(\W|$)': ' fyrir Krist\g<2>',
			 ' ([Ee]\.[Kk]r\.?)(\W|$)': ' eftir Krist\g<2>',
			 '(\W|^)([Cc]a|CA)\.?(\W|$)': '\g<1>sirka\g<3>',
			 '(\d+\.) [Ss]ek\.?(\W|$)': '\g<1> sekúnda\g<2>',
			 '(\d+\.) [Mm]ín\.?(\W|$)': '\g<1> mínúta\g<2>',
			 '(\W|^)(\d{1,2}\/\d{1,2} )frák\.?(\W|$)': '\g<1>\g<2>fráköst\g<3>',
			 '(\W|^)(\d{1,2} )stoðs\.?(\W|$)': '\g<1>\g<2>stoðsendingar\g<3>',
			 '(\W|^)([Nn]\.?k|N\.?K)\.?(\W|$)': '\g<1>næstkomandi\g<3>',
			 '(\W|^)(?i)(atr\.?)(\W|$)': '\g<1>atriði\g<3>',
			 '(\W|^)(?i)(ath\.?)(\W|$)': '\g<1>athugið\g<3>',
			 '(\W|^)(?i)(aths\.?)(\W|$)': '\g<1>athugasemd\g<3>',
			 '(\W|^)([Ff]\.?hl|F\.HL)\.?(\W|$)': '\g<1>fyrri hluti\g<3>',
			 '(\W|^)([Ss]\.?hl|S\.HL)\.?(\W|$)': '\g<1>síðari hluti\g<3>',
			 '(?i)(\W|^)(e\.?h\.?f\.?)(\W|$)': '\g<1>E H F\g<3>',
			 '(?i)(\W|^)(o\.?h\.?f\.?)(\W|$)': '\g<1>O H F\g<3>',
			 '(?i)(\W|^)(h\.?f\.?)(\W|$)': '\g<1>H F\g<3>',
			 '(?i)(\W|^)(s\.?f\.?)(\W|$)': '\g<1>S F\g<3>',
			 '(?i)(\W|^)(q\.?e\.?d\.?)(\W|$)': '\g<1>Q E D\g<3>',
			 '(\W|^)([Pp]\.?s\.?)(\W|$)': '\g<1>P S\g<3>',
			 '(\W|^)([Aa]\.?m\.?k|A\.?M\.?K)\.?(\W|$)': '\g<1>að minnsta kosti\g<3>',
			 '(\W|^)([Aa]\.m\.m\.?)(\W|$)': '\g<1>að mínu mati\g<3>',
			 '(\W|^)([Aa]\.n\.l\.?)(\W|$)': '\g<1>að nokkru leyti\g<3>',
			 '(\W|^)([Aa]lþm\.?)(\W|$)': '\g<1>alþingismaður\g<3>',
			 '(\W|^)([Aa]lm|ALM)\.?(\W|$)': '\g<1>almennt\g<3>',
			 '(\W|^)(bls\.?) (((\d{1,2}\.)?(\d{3}\.?)*\d+(,\d+)?|([Hh]undr[au]ð|HUNDR[AU]Ð|[Þþ]úsund|ÞÚSUND|[Mm]illjón(ir)?|MILLJÓN(IR)?))( )?)(\W|$)': '\g<1>blaðsíða \g<3>\g<12>',
			 '(?i)(\W|^)(B\.S[Cc]\.?)(\W|$)': '\g<1>B S C\g<3>',
			 '(?i)(\W|^)(M\.S[Cc]\.?)(\W|$)': '\g<1>M S C\g<3>',
			 '((\W|^)\() ?(e\.)(\W)': '\g<1>enska\g<4>',
			 '(\W|^)([Ee]\.k|E\.K)\.?(\W|$)': '\g<1>einhvers konar\g<3>',
			 '(\W|^)([Ee]\.?t\.?v\.?)(\W|$)': '\g<1>ef til vill\g<3>',
			 '(\W|^)([Ee]\-ð)(\W|$)': '\g<1>eitthvað\g<3>',
			 '(\W|^)([Ee]\-ju)(\W|$)': '\g<1>einhverju\g<3>',
			 '(\W|^)([Ee]\-s)(\W|$)': '\g<1>einhvers\g<3>',
			 '(\W|^)([Ee]\-r)(\W|$)': '\g<1>einhver\g<3>',
			 '(\W|^)([Ee]\-n)(\W|$)': '\g<1>einhvern\g<3>',
			 '(\W|^)([Ee]\-um)(\W|$)': '\g<1>einhverjum\g<3>',
			 '(\W|^)(f\.) (^((([012]?[1-9]|3[01])\. ?)?(jan(úar)?|feb(rúar)?|mars?|apr(íl)?|maí|jú[nl]í?|ág(úst)?|sep(t(ember)?)?|okt(óber)?|nóv(ember)?|des(ember)?) )\d{2,4}$)(\W|$)': '\g<1>fæddur \g<3>\g<4>',
			 '(\W|^)([Ff]él\.)(\W|$)': '\g<1>félag\g<3>',
			 '(\W|^)([Ff]rh|FRH)\.?(\W|$)': '\g<1>framhald\g<3>',
			 '(\W|^)([Ff]rt|FRT)\.?(\W|$)': '\g<1>framtíð\g<3>',
			 '(\W|^)([Ff]\.o\.t\.)(\W|$)': '\g<1>fyrir okkar tímatal\g<3>',
			 '(\W|^)([Gg]\.?r\.?f|G\.?R\.?F)\.?(\W|$)': '\g<1>gerum ráð fyrir\g<3>',
			 '(\W|^)([Gg]\.?m\.?g|G\.?M\.?G)\.?(\W|$)': '\g<1>guð minn góður\g<3>',
			 '(\W|^)([Hh]dl\.?)(\W|$)': '\g<1>héraðsdómslögmaður\g<3>',
			 '(\W|^)([Hh]rl\.?)(\W|$)': '\g<1>hæstaréttarlögmaður\g<3>',
			 '(\W|^)([Hh]öf|HÖF)\.?(\W|$)': '\g<1>höfundur\g<3>',
			 '(\W|^)([Hh]v?k)(\W|$)': '\g<1>hvorugkyn\g<3>',
			 '(\W|^)([Hh]r\.?)(\W|$)': '\g<1>herra\g<3>',
			 '(\W|^)([Hh]v\.?)(\W|$)': '\g<1>háttvirtur\g<3>',
			 '(\W|^)([Hh]\.u\.b|H\.U\.B)\.?(\W|$)': '\g<1>hér um bil\g<3>',
			 '(\W|^)([Kk]k)(\W|$)': '\g<1>karlkyn\g<3>',
			 '(\W|^)([Kk]vk)(\W|$)': '\g<1>kvenkyn\g<3>',
			 '(\W|^)([Kk]t\.?)(:| \d{6}\-?\d{4})?(\W|$)': '\g<1>kennitala\g<3>\g<4>',
			 '(\W|^)([Kk]l ?(\.|\:)?)(\s?\d{1,2}([:\.]\d{2})?)': '\g<1>klukkan \g<4>',
			 '(?i)(\W|^)kl ?(\.|\:)? ?((núll|eitt|tvö|þrjú|fjögur|fimm|sex|sjö|átta|níu|tíu|ellefu|tólf|((þret|fjór|fimm|sex)tán)|((sau|á|ní)tján)|tuttugu( og (eitt|tvö|þrjú|fjögur))?) )': 'klukkan \g<2>',
			 '(\W|^)([Kk]höfn|[Kk]bh|KBH)(\W|$)': '\g<1>Kaupmannahöfn\g<3>',
			 '(\W|^)([Ll]h\.?nt\.?)(\W|$)': '\g<1>lýsingarháttur nútíðar\g<3>',
			 '(\W|^)([Ll]h\.?þt\.?)(\W|$)': '\g<1>lýsingarháttur þátíðar\g<3>',
			 '(\W|^)([Ll]td|LTD)\.?(\W|$)': '\g<1>limited\g<3>',
			 '(\W|^)([Mm]\.a\.)(\W|$)': '\g<1>meðal annars\g<3>',
			 '(\W|^)([Mm]\.a\.s|M\.A\.S)\.?(\W|$)': '\g<1>meira að segja\g<3>',
			 '(\W|^)([Mm]\.a\.o|M\.A\.O)\.?(\W|$)': '\g<1>meðal annarra orða\g<3>',
			 '((\d{1,2}\.)?(\d{3}\.?)*\d+(,\d+)?|([Hh]undr[au]ð|HUNDR[AU]Ð|[Þþ]úsund|ÞÚSUND|[Mm]illjón(ir)?|MILLJÓN(IR)?)) ?([Mm]\.y\.s\.?)(\W|$)': '\g<1> metra yfir sjávarmáli\g<9>',
			 '([02-9] )([Mm]illj\.?)(\W|$)': '\g<1>milljónir\g<3>',
			 '(1 )([Mm]illj\.?)(\W|$)': '\g<1>milljónir\g<3>',
			 '(\W|^)([Mm]\.?v\.?)(\W|$)': '\g<1>miðað við\g<3>',
			 '(\W|^)([Mm]\.?t\.?t|M\.?T\.?T)\.?(\W|$)': '\g<1>með tilliti til\g<3>',
			 '(\W|^)([Mm]\.?ö\.?o|M\.?Ö\.?O)\.?(\W|$)': '\g<1>með öðrum orðum\g<3>',
			 '(\W|^)([Mm]fl|MFL)\.?(\W|$)': '\g<1>meistaraflokkur\g<3>',
			 '((\d{1,2}\.)?(\d{3}\.?)*\d+(,\d+)?|([Hh]undr[au]ð|HUNDR[AU]Ð|[Þþ]úsund|ÞÚSUND|[Mm]illjón(ir)?|MILLJÓN(IR)?)) ?(m ?\^ ?2)(\W|$)': '\g<1> fermetrar\g<9>',
			 '((\d{1,2}\.)?(\d{3}\.?)*\d+(,\d+)?|([Hh]undr[au]ð|HUNDR[AU]Ð|[Þþ]úsund|ÞÚSUND|[Mm]illjón(ir)?|MILLJÓN(IR)?)) ?(m ?\^ ?3)(\W|$)': '\g<1> rúmmetrar\g<9>',
			 '(\W|^)([Nn]úv\.?)(\W|$)': '\g<1>núverandi\g<3>',
			 '(\W|^)([Nn]\.?t\.?t|N\.?T\.T)\.?(\W|$)': '\g<1>nánar tiltekið\g<3>',
			 '(\W|^)([Nn]kl|NKL)(\W|$)': '\g<1>nákvæmlega\g<3>',
			 '(\W|^)([Oo]\.?fl|O\.?FL)\.?(\W|$)': '\g<1>og fleira\g<3>',
			 '(\W|^)([Oo]\.?m\.?fl|O\.?M\.?FL)\.?(\W|$)': '\g<1>og margt fleira\g<3>',
			 '(\W|^)([Oo]\.?s\.?frv?|O\.?S\.?FRV?)\.?(\W|$)': '\g<1>og svo framvegis\g<3>',
			 '(\W|^)([Oo]\.?þ\.?h|O\.?Þ\.?H)\.?(\W|$)': '\g<1>og þess háttar\g<3>',
			 '(\W|^)([Oo]\.þ\.u\.l|O\.Þ\.U\.L)\.?(\W|$)': '\g<1>og því um líkt\g<3>',
			 '(\W|^)(([Ss]íma)?nr\.?) ': '\g<1>\g<3>númer ',
			 '(\W|^)([Pp]k\.?)(\W|$)': '\g<1>pakki\g<3>',
			 '(\W|^)([Rr]n\.?)(:| [\d\-]+)(\W|$)': '\g<1>reikningsnúmer\g<3>\g<4>',
			 '(\W|^)([Rr]itstj\.?)(\W|$)': '\g<1>ritstjóri\g<3>',
			 '(\W|^)([Rr]slm\.?)(\W|$)': '\g<1>rannsóknarlögreglumaður\g<3>',
			 '(\W|^)([Rr]ví?k|RVÍ?K)(\W|$)': '\g<1>Reykjavík\g<3>',
			 '(\W|^)([Ss]\.?)(:| \d{3}\-?\d{4}|\d{7})(\W|$)': '\g<1>sími\g<3>\g<4>',
			 '(\W|^)([Ss]br\.?)(\W)': '\g<1>samanber\g<3>',
			 '(\W|^)([Ss]\.?l\.?|SL\.)(\W|$)': '\g<1>síðastliðinn\g<3>',
			 '(\W|^)([Ss]\.?k\.?)(\W|$)': '\g<1>svokallað\g<3>',
			 '(\W|^)([Ss]kv|SKV)\.?(\W|$)': '\g<1>samkvæmt\g<3>',
			 '(\W|^)([Ss]\. ?s\.?)(\W|$)': '\g<1>svo sem\g<3>',
			 '(\W|^)([Ss]amþ|SAMÞ)\.?(\W|$)': '\g<1>samþykki\g<3>',
			 '(\W|^)([Ss]gt\.?)(\W|$)': '\g<1>sergeant\g<3>',
			 '(\W|^)([Ss]t\.?)(\W|$)': '\g<1>saint\g<3>',
			 '(\W|^)([Ss]ltjn|SLTJN)\.?(\W|$)': '\g<1>Seltjarnarnes\g<3>',
			 '(\W|^)([Ss]thlm|STHLM)(\W|$)': '\g<1>Stokkhólmur\g<3>',
			 '(\W|^)([Tt]bl|TBL)\.?(\W|$)': '\g<1>tölublað\g<3>',
			 '(\W|^)([Tt]l\.?)(\W|$)': '\g<1>tengiliður\g<3>',
			 '(\W|^)([Tt]\.h\.?)(\W|$)': '\g<1>til hægri\g<3>',
			 '(\W|^)([Tt]\.v\.?)(\W|$)': '\g<1>til vinstri\g<3>',
			 '(\W|^)([Tt]\.a\.m|T\.A\.M)\.?(\W|$)': '\g<1>til að mynda\g<3>',
			 '(\W|^)([Tt]\.?d|T\.?D)\.?(\W|$)': '\g<1>til dæmis\g<3>',
			 '(\W|^)([Uu]\.?þ\.?b|U\.?Þ\.?B)\.?(\W|$)': '\g<1>um það bil\g<3>',
			 '(\W|^)([Uu]ppl|UPPL)\.?(\W|$)': '\g<1>upplýsingar\g<3>',
			 '(\W|^)([Uu]td|UTD)\.?(\W|$)': '\g<1>united\g<3>',
			 '(\W|^)([Vv]s|VS)\.?(\W|$)': '\g<1>versus\g<3>',
			 '(\W|^)([Vv]sk\.?)(\W|$)': '\g<1>virðisaukaskatt\g<3>',
			 '(\W|^)([Ff]\.h\.?)(\W|$)': '\g<1>fyrir hönd\g<3>',
			 '(\W|^)([Dd]r\.?)(\W|$)': '\g<1>doktor\g<3>',
			 '([A-ZÁÐÉÍÓÚÝÞÆÖa-záðéíóúýþæö]+ )([Jj]r)\.?(\W|$)': '\g<1>junior\g<3>',
			 '(\W|^)([Þþ]f\.?)(\W|$)': '\g<1>þolfall\g<3>',
			 '(\W|^)([Þþ]gf\.?)(\W|$)': '\g<1>þágufall\g<3>',
			 '(\W|^)([Þþ]lt\.?)(\W|$)': '\g<1>þáliðin tíð\g<3>',
			 '(\W|^)([Þþ]\.á\.)(\W|$)': '\g<1>þessa árs\g<3>',
			 '(\W|^)([Þþ]\.h\.)(\W|$)': '\g<1>þess háttar\g<3>',
			 '(\W|^)([Þþ]\.m\.)(\W|$)': '\g<1>þessa mánaðar\g<3>',
			 '(\W|^)([Þþ]\.?e\.?a\.?s|Þ\.?E\.?A\.?S)\.?(\W|$)': '\g<1>það er að segja\g<3>',
			 '(\W|^)([Þþ]\.e\.)(\W|$)': '\g<1>það er\g<3>',
			 '(\W|^)([Þþ]\.?þ\.?a\.?a|Þ\.?Þ\.?A\.?A)\.?(\W|$)': '\g<1>þá og því aðeins að\g<3>',
			 '(\W|^)([Þþ]\.a\.l|Þ\.A\.L)\.?(\W|$)': '\g<1>þar af leiðandi\g<3>',
			 '(\W|^)([Þþ]\.a\.?)(\W|$)': '\g<1>þannig að\g<3>',
			 '(\W|^)([Þþ]\.u\.l|Þ\.U\.L)\.?(\W|$)': '\g<1>því um líkt\g<3>',
			 '(\W|^)([þÞ]\.á(\.| )m|Þ\.Á(\.| )M)\.?(\W|$)': '\g<1>þar á meðal\g<3>',
			 '(\W|^)([Þþ]\.m\.t|Þ\.M\.T)\.?(\W|$)': '\g<1>þar með talið\g<3>',
			 '(((((\d{1,2}\.)?(\d{3}\.)*\d{3}|\d+)(,\d+)?|([Hh]undr[au]ð|HUNDR[AU]Ð|[Mm]illjón(ir)?|MILLJÓN(IR)?))( )?)\s)(þús\.?)( [A-ZÁÐÉÍÓÚÝÞÆÖa-záðéíóúýþæö]*)': ' \g<1>þúsund\g<13>',
			 '([Mm]örg )þús\.?( [A-ZÁÐÉÍÓÚÝÞÆÖa-záðéíóúýþæö]*)': ' \g<1>þúsund\g<2>',
			 '(\d+\.) [Áá]rg\.(\W|$)': '\g<1> árgangur\g<2>',
			 '(\W|^)([Óó]ákv\.gr\.)(\W|$)': '\g<1>óákveðinn greinir\g<3>',
			 '(\d+\.) útg\.(\W|$)': '\g<1> útgáfa\g<2>',
			 '(\W|^)([Íí]sl|ÍSL)\.?(\W|$)': '\g<1>íslenska\g<3>',
			 '([02-9])( )?°C(\W|$)': '\g<1> gráður á selsíus\g<3>',
			 '(1)( )?°C(\W|$)': '\g<1> gráða á selsíus\g<3>',
			 '([02-9])( )?°F(\W|$)': '\g<1> gráður á fahrenheit\g<3>',
			 '(1)( )?°F(\W|$)': '\g<1> gráða á fahrenheit\g<3>',
			 '([02-9])( )?°W(\W|$)': '\g<1> gráður vestur\g<3>',
			 '(1)( )?°W(\W|$)': '\g<1> gráða vestur\g<3>',
			 '([02-9])( )?°N(\W|$)': '\g<1> gráður norður\g<3>',
			 '(1)( )?°(\W|$)': '\g<1> gráða norður\g<3>',
			 '([02-9])( )?°E(\W|$)': '\g<1> gráður austur\g<3>',
			 '(1)( )?°E(\W|$)': '\g<1> gráða austur\g<3>',
			 '([02-9])( )?°S(\W|$)': '\g<1> gráður suður\g<3>',
			 '(1)( )?°S(\W|$)': '\g<1> gráða suður\g<3>'}
